#!/usr/bin/perl
# ------------------------------------------------------------------------------
# File Name:            graphbar.pl
# Author:               Richard Mayhew - South Africa
# Date:                 1999/11/16
# Version:              1.0
# Description:          This script will generate graphs
#                       for use in NetSaint Reports
#
# Email:                netsaint@splash.co.za
#
# ------------------------------------------------------------------------------
# Copyright 1999 (c) Richard Mayhew
# Credits go to Ethan Galstad for coding NetSaint
# If any changes are made to this script, please mail me a copy of the
# changes :)
# License GPL
# ------------------------------------------------------------------------------
# Date          Author          Reason
# ----          ------          ------
# 1999/09/28    RM              Creation
# -----------------------------------------------------------------[ Require ]--
require 5.004;
# --------------------------------------------------------------------[ Uses ]--
use strict;
# --------------------------------------------------------------[ Enviroment ]--
$ENV{PATH} = "/bin";
$ENV{BASH_ENV} = "";
$ENV{ENV} = "";
$|=1;
use PNGgraph::bars;
use PNGgraph::colour;
my $file = shift || &usage;
my $graphs ="/usr/local/netsaint/share/reports/graphs/";
my $database = "/usr/local/netsaint/report/database/";
my $wclocation = "/usr/bin/wc";
my @data =  read_data_from_csv("$database$file")
    or die "Cannot read data from $database$file";

my $my_graph = new PNGgraph::bars(&size_x, 300 );

$my_graph->set(
    x_label => 'Servers',
    y_label => 'Total Minutes',
    title => &date,
    y_max_value => &max,
    y_tick_number => 10,
    y_label_skip => 1,
    bar_spacing => 10,
    dclrs => [ qw( purple blue ) ],	
    fgclr => 'black',
    logo => '/usr/local/netsaint/report/logo.png',
    logo_position => 'LL',
#    long_ticks => 1,
);
my $output = $file;
$output =~ s/.*database\///g;

$my_graph->set_legend( 'Server Down Time' );
$my_graph->plot_to_png( "$graphs$output.png", \@data );

exit;


sub date 
{
my $date;

$date = `/bin/date`;
$date =~ s/\n//g;

return "Generated on :- $date";
}
sub size_x
{
my $newnumber = 0;
my $number = `$wclocation -l $database$file`;
if ($number < 8) {
	$newnumber = 400;
		}

else 	{
$newnumber = $number * 50

	}
return $newnumber;
}

sub max
{
my $starttime = 0;
my $log_file = "";
open (LOG_FILE, "$database$file") or die "Error Opening $database$file File!\n";
        while (<LOG_FILE>) {
                my $log_file .= $_;
        }
        close(LOG_FILE);

        my @Data = split(/\n/,$log_file);
        my $rowss = @Data;
	my $x = 0;
        for($x=0;$x<$rowss;$x++) {

                        $Data[$x] =~ s/\,/ /g;
                        my @time = split(' ',$Data[$x]);

		if ($time[1] > $starttime) 
		{ $starttime = $time[1];
		}        	
       
        }

return int($starttime + 20);
}

sub read_data_from_csv
{
    my $fn = shift;
    my @d = ();

    open(ZZZ, $fn) || return ();

    while (<ZZZ>)
    {
        chomp;
        # you might want Text::CSV here
        my @row = split /,/;

        for (my $i = 0; $i <= $#row; $i++)
        {
            undef $row[$i] if ($row[$i] eq 'undef');
            push @{$d[$i]}, $row[$i];
        }
    }

    close (ZZZ);

    return @d;
}
sub usage
{
print "Usage :- graphbar.pl <GRAPH INPUT FILE>\n";
exit;
}
