#!/usr/bin/perl
# ------------------------------------------------------------------------------
# File Name:            grabservice.pl
# Author:               Richard Mayhew - South Africa
# Date:                 1999/11/16
# Version:              1.0
# Description:          This script will initialise the config files
#                       for use in NetSaint Reports
#
# Email:                netsaint@splash.co.za
#
# ------------------------------------------------------------------------------
# Copyright 1999 (c) Richard Mayhew
# Credits go to Ethan Galstad for coding NetSaint
# If any changes are made to this script, please mail me a copy of the
# changes :)
# License GPL
# ------------------------------------------------------------------------------
# Date          Author          Reason
# ----          ------          ------
# 1999/09/28    RM              Creation
# -----------------------------------------------------------------[ Require ]--
require 5.004;
# --------------------------------------------------------------------[ Uses ]--
use strict;
# --------------------------------------------------------------[ Enviroment ]--
$ENV{PATH} = "/bin";
$ENV{BASH_ENV} = "";
$ENV{ENV} = "";
$|=1;
my $greplocation = "/bin/grep";
my $sortlocation = "/bin/sort";
my $tempgroup = "/tmp/grabtempgroup";
my $tempservice = "/tmp/grabtempservice";
my $temphost = "/tmp/grabtemphost";
my $data = "/usr/local/netsaint/etc/hosts.cfg";

sub GrabbingGroups
{
print "Generating List Of Groups.\n";

        my @tDown = `$greplocation "hostgroup\\[" $data`;
        my $rowss = @tDown;
	my $x = 0;
        for($x=0;$x<$rowss;$x++) {
                        if($tDown[$x] !~ /#/) {
                        $tDown[$x] =~ s/\ /_/g;
                        $tDown[$x] =~ s/\]/ /g;
                        $tDown[$x] =~ s/\[/ /g;
                        $tDown[$x] =~ s/\;/ /g;
                        $tDown[$x] =~ s/\#//g;
                        $tDown[$x] =~ s/\=//g;
                        my @data1 = split(' ',$tDown[$x]);

                                open (GROUPCFG_FILE, ">>$tempgroup");
                                print GROUPCFG_FILE "$data1[1];$data1[4]\n";
                                close (GROUPCFG_FILE);
		}
        }
}

sub GrabbingServices
{
print "Generating List Of Host's Services.\n";
system("rm -f service.cfg >/dev/null 2>&1");

        my @tDown = `$greplocation "service\\[" $data`;
        my $rowss = @tDown;
	my $x = 0;
        for($x=0;$x<$rowss;$x++) {
                        if($tDown[$x] !~ /#/) {
                        $tDown[$x] =~ s/\]/ /g;
                        $tDown[$x] =~ s/\[/ /g;
                        $tDown[$x] =~ s/\;/ /g;
                        $tDown[$x] =~ s/\=/ /g;
                        $tDown[$x] =~ s/\#//g;
                 my @data1 = split(' ',$tDown[$x]);

                                open (SRVHOST_FILE, ">>$tempservice");
                                print SRVHOST_FILE "$data1[1];$data1[2]\n";
                                close (SRVHOST_FILE);
		}
        }
&Convert;
}

sub readFile
{
        my ($in_file) = @_;
        my $out_file = "";

        open (IN_FILE,"<$in_file");
        while (<IN_FILE>) {
                $out_file .= $_;
        }
        close(IN_FILE);
        return $out_file;
}

sub Convert
{
        my %output_array = ();
        my ($server,$service);

        my $input_data = &readFile("$tempservice");
        my @input_array = split(/\n/,$input_data);
	my $line ="";
	my $services = "";
	my $server = "";
        foreach $line (@input_array) {
                ($server,$service) = split(/\;/,$line);
                $output_array{$server} .= "$service,";
        }

        open (OUT_FILE,">$tempservice") or die "Error Opening $tempservice File!\n";
        while (($server,$services) = each(%output_array)) {
                chop($services);        # get rid of the last comma
                print OUT_FILE "$server;$services\n";
        }
        close(OUT_FILE);
}

sub GrabbingHosts
{
print "Generating List Of Hosts.\n";

        my @tDown = `$greplocation "host\\[" $data`;
        my $rowss = @tDown;
	my $x = 0;
        for($x=0;$x<$rowss;$x++) {
                        if($tDown[$x] !~ /#/) {
                        $tDown[$x] =~ s/\]/ /g;
                        $tDown[$x] =~ s/\[/ /g;
                        $tDown[$x] =~ s/\;/ /g;
                        $tDown[$x] =~ s/\#//g;
                        my @data1 = split(' ',$tDown[$x]);

                                open (CHECKCFG_FILE, ">>$temphost");
                                print CHECKCFG_FILE "$data1[1]\n";
                                close (CHECKCFG_FILE);
		}
        }
}

sub sorting
{
print "Sorting.\n";

`$sortlocation $tempgroup > group.cfg`;
`$sortlocation $tempservice > service.cfg`;
`$sortlocation $temphost > hosts.cfg`;
system("rm -f $temphost >/dev/null 2>&1");
system("rm -f $tempservice >/dev/null 2>&1");
system("rm -f $tempgroup >/dev/null 2>&1");
}

sub Banner
{
print "|------------------NetSaint Reports v1.0----------------|\n";
print "|   ^^^^                                                |\n";
print "|   (o<          Copywrite Richard Mayhew 1999          |\n";
print "|   //\          Licence GPL                             |\n";
print "|   V_/_                                                |\n";
print "|-------------------------------------------------------|\n";
print "";
}

MAIN:
{
system("/usr/bin/clear");
Banner;
GrabbingGroups;
GrabbingHosts;
GrabbingServices;
sorting;
print "All Done!.\n";
}

