#!/usr/bin/perl
# ------------------------------------------------------------------------------
# File Name:            graphbar.pl
# Author:               Richard Mayhew - South Africa
# Date:                 1999/11/16
# Version:              1.0
# Description:          This script will initialise the database
#                       for use in NetSaint Reports
#
# Email:                netsaint@splash.co.za
#
# ------------------------------------------------------------------------------
# Copyright 1999 (c) Richard Mayhew
# Credits go to Ethan Galstad for coding NetSaint
# If any changes are made to this script, please mail me a copy of the
# changes :)
# License GPL
# ------------------------------------------------------------------------------
# Date          Author          Reason
# ----          ------          ------
# 1999/09/28    RM              Creation
# -----------------------------------------------------------------[ Require ]--
require 5.004;
# --------------------------------------------------------------------[ Uses ]--
use strict;
# --------------------------------------------------------------[ Enviroment ]--
$ENV{PATH} = "/bin";
$ENV{BASH_ENV} = "";
$ENV{ENV} = "";
$|=1;

sub server
{
	my $srv_file = "";
        my @Data = ();
	my $rowss = "";
	my $x = 0;
	my @server = ();

	open (SLOG_FILE, "hosts.cfg") or die "Error Opening hosts.cfg File!\n";

        while (<SLOG_FILE>) {
                $srv_file .= $_;
        }
        close(SLOG_FILE);

        @Data = split('\n',$srv_file);
        $rowss = @Data;
	$x = 0;
        for($x=0;$x<$rowss;$x++) {

               @server = split('\n',$Data[$x]);

		if (-e "database/$server[0]-Yearly") {
			print "File $server[0]-Yearly Exists\n";

		} else {
			open (SERVER, ">database/$server[0]-Yearly");
			print SERVER "Jan,0\n";
			print SERVER "Feb,0\n";
			print SERVER "Mar,0\n";
			print SERVER "Apr,0\n";
			print SERVER "May,0\n";
			print SERVER "Jun,0\n";
			print SERVER "Jul,0\n";
			print SERVER "Aug,0\n";
			print SERVER "Sep,0\n";
			print SERVER "Oct,0\n";
			print SERVER "Nov,0\n";
			print SERVER "Dec,0";
			close (SERVER);
		}
        }
}

sub group
{
	my $grp_file = "";
	my @group_data = ();
	my $group = "";
	my $hosts = "";
	my $host = "";
	my @host_data = ();
	my $group_name = "";

	open (GLOG_FILE, "group.cfg") or die "Error Opening group.cfg File!\n";
        while (<GLOG_FILE>) {
                $grp_file .= $_;
        }
        close(GLOG_FILE);

        @group_data = split(/\n/, $grp_file);

	foreach $group (@group_data) {

                ($group_name,$hosts) = split(/\;/,$group);
		@host_data = split(/\,/,$hosts);

	                open (GROUP, ">database/$group_name-Group");

			foreach $host (sort @host_data) {
				print GROUP "$host,0\n";
			}

			close (GROUP);
	}
}

sub service
{
        my $srv_file = "";
        my @srv_data = ();
        my $hostname = "";
        my $service = "";
	my $host = "";
        my @serv_data = ();

        open (SRV_FILE, "service.cfg") or die "Error Opening service.cfg File!\n";
        while (<SRV_FILE>) {
                $srv_file .= $_;
        }
        close(SRV_FILE);

        @srv_data = split(/\n/, $srv_file);

        foreach $host (@srv_data) {

                ($hostname,$service) = split(/\;/,$host);
                @serv_data = split(',',$service);
                if (-e "database/$hostname-Services") {
                        print "File $hostname-Services Exists\n";

                } else {
                        open (SRV, ">database/$hostname-Services");

                        foreach $service (sort @serv_data) {
                                print SRV "$service,0\n";
                        }

                        close (SRV);
                }
        }
}
sub serviceyear
{
	my $srvyear_file = "";
        my @srvyear_data = ();
        my $srvyear = "";
        my $srvsyear = "";
	my @YearData = ();
	my @serviceyear = "";
	my $service = "";
	my $host_name = "";
	my $rowss = 0;
	my $x = 0;

        open (YEARLOG_FILE, "service.cfg") or die "Error Opening service.cfg File!\n";

        while (<YEARLOG_FILE>) {
                $srvyear_file .= $_;
        }
        close(YEARLOG_FILE);

        @YearData = split('\n',$srvyear_file);
        $rowss = @YearData;

        for($x=0;$x<$rowss;$x++) {
		($host_name,$service) = split(/\;/,$YearData[$x]);
                @serviceyear = split(',',$service);
	foreach $service (sort @serviceyear) {

                if (-e "database/$host_name-$service-Yearly") {
                        print "File $host_name-$service-Yearly Exists\n";

                } else {
                        open (SERVER, ">database/$host_name-$service-Yearly");
                        print SERVER "Jan,0\n";
                        print SERVER "Feb,0\n";
                        print SERVER "Mar,0\n";
                        print SERVER "Apr,0\n";
                        print SERVER "May,0\n";
                        print SERVER "Jun,0\n";
                        print SERVER "Jul,0\n";
                        print SERVER "Aug,0\n";
                        print SERVER "Sep,0\n";
                        print SERVER "Oct,0\n";
                        print SERVER "Nov,0\n";
                        print SERVER "Dec,0";
                        close (SERVER);
                }
        }
}
}

MAIN: 
{
print "Initialising Yearly Servers\n";
group;
server;
service;
serviceyear;
`chown -R nobody:nobody database/`;
print "Done!\n";
}
