#!/usr/bin/perl
# ------------------------------------------------------------------------------
# File Name:            table.cgi
# Author:               Richard Mayhew - South Africa
# Date:                 1999/11/16
# Version:              1.0
# Description:          This script will generate tables
#                       for use in NetSaint Reports
#
# Email:                netsaint@splash.co.za
#
# ------------------------------------------------------------------------------
# Copyright 1999 (c) Richard Mayhew
# Credits go to Ethan Galstad for coding NetSaint
# If any changes are made to this script, please mail me a copy of the
# changes :)
# License GPL
# ------------------------------------------------------------------------------
# Date          Author          Reason
# ----          ------          ------
# 1999/09/28    RM              Creation
# -----------------------------------------------------------------[ Require ]--
require 5.004;
# --------------------------------------------------------------------[ Uses ]--
use strict;
# --------------------------------------------------------------[ Enviroment ]--
$ENV{PATH} = "/bin";
$ENV{BASH_ENV} = "";
$ENV{ENV} = "";
$|=1;
my $data = shift || &usage;
my $database = "/usr/local/netsaint/report/database/";
my $date = `/bin/date '+%B %Y'`;
my $counterfile = "/usr/local/netsaint/report/counter";
split;
open (COUNTER, "$counterfile");
my $counterhost = <COUNTER>;
my $counterservices = <COUNTER>;
close (COUNTER);

print "Content-type: text/html\n\n<HTML>\n<HEAD>\n<TITLE>NetSaint Server Graph For $data</TITLE>\n</HEAD>\n<BODY BACKGROUND=\"/netsaint/images/backg.jpg\" BGCOLOR=\"#e8e8ff\">";
print "<CENTER><h2><U>Total Down Time in Minutes for $data for $date</h2></U><br>\n";
print "<B>Total Computed Host Entries :- $counterhost\n<BR>";
print "Total Computed Services Entries :- $counterservices\n<BR></B>";
print "<TABLE BGCOLOR=\"#FFFFFF\" BORDER=\"1\" CELLSPACING=\"1\" CELLPADDING=\"1\" BORDERCOLORLIGHT=\"#FFCCFF\" BORDERCOLORDARK=\"#000000\">\n";
print "<TR><TD>Name</TD>\n<TD>Time Down</TD>\n<TD>% Down</TD>\n<TD>% Up</TD></TR>";

&check;
&output;

print "</CENTER></TABLE></BODY></HTML>\n";

sub check
{

`/usr/local/netsaint/report/check.pl`;
}

sub output
{
my $month = "";
my $dayone = "";
my $present = "";
my $percent = "";
my $service = "";
my $host = "";
my $host_name = "";
my $sla = "";

$month = `/bin/date +%b`;
$dayone = `/bin/date +%s --date '1 $month'`;
$present = `/bin/date +%s`;
$present = (($present - $dayone) / 60);

        my $srv_file = "";
        my @srv_data = ();
	my $colour = "BGCOLOR=\"#66FF33\"";
        open (SRV_FILE, "$database$data") or die "Error Opening service File!\n";
        while (<SRV_FILE>) {
                $srv_file .= $_;
        }
        close(SRV_FILE);

        @srv_data = split(/\n/, $srv_file);

        foreach $host (@srv_data) {

                ($host_name,$service) = split(/\,/,$host);

$percent = (($service / $present) * 100);
$percent = sprintf("%.2f",$percent);
$service = sprintf("%.2f",$service);
$sla = (100 - $percent);
$sla = sprintf("%.2f",$sla);
 
if (($service > 5) && ($service < 20)) { $colour = "BGCOLOR=\"#FFCC66\""; }

elsif ($service > 20 ) { $colour = "BGCOLOR=\"#FF3366\""; }

print "<TR><TD>$host_name</TD>\n<TD $colour>$service</TD>\n<TD $colour>$percent %</TD>\n<TD $colour>$sla %</TD</TR>";
$colour = "BGCOLOR=\"#66FF33\"";
        }
}

sub usage
{
print "Content-type: text/html\n\n<HTML>\n<HEAD>\n<TITLE>NetSaint Server Graph For $data</TITLE>\n</HEAD>\n<BODY BACKGROUND=\"/netsaint/images/backg.jpg\" BGCOLOR=\"#e8e8ff\">";
print "Usage :- table.cgi graphname\n";
exit;
}
