#!/usr/bin/perl5
# ------------------------------------------------------------------------------
# File Name:            tableold.cgi
# Author:               Richard Mayhew - South Africa
# Date:                 1999/09/28
# Version:              1.0
# Description:          This script will generate tables
#                       for use in NetSaint Reports
#
# Email:                netsaint@splash.co.za
#
# ------------------------------------------------------------------------------
# Copyright 1999 (c) Richard Mayhew
# Credits go to Ethan Galstad for coding NetSaint
# If any changes are made to this script, please mail me a copy of the
# changes :)
# License GPL
# ------------------------------------------------------------------------------
# Date          Author          Reason
# ----          ------          ------
# 1999/09/28    RM              Creation
# -----------------------------------------------------------------[ Require ]--
require 5.004;
# --------------------------------------------------------------------[ Uses ]--
use strict;
# --------------------------------------------------------------[ Enviroment ]--
$ENV{PATH} = "/bin";
$ENV{BASH_ENV} = "";
$ENV{ENV} = "";
$|=1;
my $data = shift || &usage;
my $database = "/usr/local/netsaint/report/databaseold/";

my $date = `/bin/date --date '1 month ago' '+%B %Y'`;
my $top="Content-type: text/html\n\n<HTML>\n<HEAD>\n<TITLE>NetSaint Server Graph For $data</TITLE>\n</HEAD>\n<BODY BACKGROUND=\"/images/backg.jpg\" BGCOLOR=\"#e8e8ff\">";

print "$top\n";
print "<CENTER><h2><U>Total Down Time in Minutes for $data for ($date)</h2></U><br>\n";
print "<TABLE BGCOLOR=\"#FFFFFF\" BORDER=\"1\" CELLSPACING=\"1\" CELLPADDING=\"1\" BORDERCOLORLIGHT=\"#FFCCFF\" BORDERCOLORDARK=\"#000000\">\n";
print "<TR><TD>Name</TD>\n<TD>Time Down</TD>\n<TD>% Down</TD>\n<TD>% Up</TD></TR>";

&output;

print "</CENTER></TABLE></BODY></HTML>\n";

sub output
{

my $month = `/bin/date --date '1 month ago' '+%b'`;
$month =~ s/\n//g;
sub leap
{
my $leap = `/bin/date --date '29 Feb' '+%-d'`;
	if ($leap != 29) 
	{
	$leap = 28;
	}
return $leap;
}

my %days = (Jan => 31, Feb => &leap, Mar => 31, Apr => 30, May => 31, Jun => 30, Jul => 31, Aug => 31, Sep => 30, Oct => 31, Nov => 30, Dec => 31);
my $present = ($days{$month} * 24) * 60;

        my $srv_file = "";
        my @srv_data = ();
	my $host = "";
	my $service = "";
	my $host_name = "";
	my $percent = "";
	my $sla = "";
	my $colour = "BGCOLOR=\"#66FF33\"";
        open (SRV_FILE, "$database$data") or die "Error Opening service File!\n";
        while (<SRV_FILE>) {
                $srv_file .= $_;
        }
        close(SRV_FILE);

        @srv_data = split(/\n/, $srv_file);

        foreach $host (@srv_data) {

                ($host_name,$service) = split(/\,/,$host);

$percent = (($service / $present) * 100);
$percent = sprintf("%.2f",$percent);
$service = sprintf("%.2f",$service);
$sla = (100 - $percent);
$sla = sprintf("%.2f",$sla);
 
if (($service > 5) && ($service < 20)) { $colour = "BGCOLOR=\"#FFCC66\""; }

elsif ($service > 20 ) { $colour = "BGCOLOR=\"#FF3366\""; }

print "<TR><TD>$host_name</TD>\n<TD $colour>$service</TD>\n<TD $colour>$percent %</TD>\n<TD $colour>$sla %</TD</TR>";
$colour = "BGCOLOR=\"#66FF33\"";
        }
}

sub usage
{
print "$top\n";
print "Usage :- tableold.cgi <GRAPHNAME>\n";
exit;
}
